<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>Website Stats | <cfoutput>#Application.ApplicationName#</cfoutput></title>
<style>
@import url("/css/default.css");
</style>

<script type="text/javascript" src="/js/prototype.js"></script>

<!-- user vars -->
<cfset AccessRequired = TRUE>
<cfset AccessAllowed = "Webmaster,Administrator">
<!-- user vars -->

</head>
<body class="administrator">
<cfif not AccessRequired or (IsDefined("Session.Access") and ListFind(AccessAllowed,Session.Access))>
	<cfinclude template="/padsite/views/_nav.cfm">
	
	<cfparam name="form.intervalcount" default="12">
  <cfparam name="form.interval" default="Day">
  <cfset Interval = SpanExcluding(form.interval,Application.psIllegal_URL_Chars)>
  <cfset IntervalCount = Val(form.intervalcount)>
	<cfif Interval eq "Minute">
		<cfset AdjNowDate = CreateDateTime(Year(Now()),Month(Now()),Day(Now()),Hour(Now()),Minute(Now()),0)>
		<cfelseif Interval eq "Hour">
		<cfset AdjNowDate = CreateDateTime(Year(Now()),Month(Now()),Day(Now()),Hour(Now()),0,0)>
		<cfelseif Interval eq "Month">
		<cfset AdjNowDate = CreateDate(Year(Now()),Month(Now()),1)>
		<cfelseif Interval eq "Year">
		<cfset AdjNowDate = CreateDate(Year(Now()),1,1)>
		<cfelse><!--- day or week --->
		<cfset AdjNowDate = CreateDate(Year(Now()),Month(Now()),Day(Now()))>
	</cfif>
  <cfquery name="Stats" dataSource="#Application.psDataSource#">
  select * from #Application.psStatsTable# where SessionStarted_dt > dateadd(#Interval#,-#IntervalCount#,#AdjNowDate#) and UserAgent not like '%bot%' and UserAgent not like '%spider%' order by SessionStarted_dt desc
  </cfquery>
  <cfquery name="Pages" dataSource="#Application.psDataSource#">
  select * from #Application.psPagesTable# order by Queue
  </cfquery>
  
  <cfset PageList = ValueList(Pages.PageName)>
  <cfset HistoryList = ValueList(Stats.SessionHistory,"|")>
  <cfset RefererList = ValueList(Stats.SessionReferer,"|")>
  <cfset UserAgentList = ValueList(Stats.UserAgent,"|")>
  
  <cfset PageCountList = "">
  <cfloop list="#PageList#" index="CurrentPage">
  	<cfset PageCountList = ListAppend(PageCountList,ListValueCount(HistoryList,Replace(CurrentPage," ","-","all"),",|"))>
  </cfloop>
  <cfset RefererCountList = "">
  <cfloop list="#RefererList#" index="CurrentReferer" delimiters="|">
  	<cfset RefererCountList = ListAppend(RefererCountList,ListValueCount(RefererList,CurrentReferer,"|"))>
  </cfloop>
  <cfset UserAgentCountList = "">
  <cfloop list="#UserAgentList#" index="CurrentAgent" delimiters="|">
  	<cfset UserAgentCountList = ListAppend(UserAgentCountList,ListValueCount(UserAgentList,CurrentAgent,"|"))>
  </cfloop>
  
  <cfset TotalPageViews = ArraySum(ListToArray(PageCountList))>
  <cfif TotalPageViews eq 0><cfset TotalPageViews = 1></cfif>
  <cfset PageRouteList = "">
  <cfset PageRouteCounterList = "">
  <cfloop list="#HistoryList#" index="CurrentHistoryList" delimiters="|">
  	<cfif not ListFind(PageRouteList,CurrentHistoryList,"|")>
  		<cfset PageRouteList = ListAppend(PageRouteList,CurrentHistoryList,"|")>
  		<cfset PageRouteCounterList = ListAppend(PageRouteCounterList,ListValueCount(HistoryList,CurrentHistoryList,"|"),"|")>
  	</cfif>
  </cfloop>
  <cfset UniqueRefererList = "">
  <cfset UniqueRefererCounterList = "">
  <cfloop list="#RefererList#" index="CurrentReferer" delimiters="|">
  	<cfif not ListFind(UniqueRefererList,CurrentReferer,"|")>
  		<cfset UniqueRefererList = ListAppend(UniqueRefererList,CurrentReferer,"|")>
  		<cfset UniqueRefererCounterList = ListAppend(UniqueRefererCounterList,ListValueCount(RefererList,CurrentReferer,"|"),"|")>
  	</cfif>
  </cfloop>
  <cfset UniqueUserAgentList = "">
  <cfset UniqueUserAgentCounterList = "">
  <cfloop list="#UserAgentList#" index="CurrentAgent" delimiters="|">
  	<cfif not ListFind(UniqueUserAgentList,CurrentAgent,"|")>
  		<cfset UniqueUserAgentList = ListAppend(UniqueUserAgentList,CurrentAgent,"|")>
  		<cfset UniqueUserAgentCounterList = ListAppend(UniqueUserAgentCounterList,ListValueCount(UserAgentList,CurrentAgent,"|"),"|")>
  	</cfif>
  </cfloop>
  
  <!--- convert to paired arrays and sort as linked rows --->
  <cfset PageRouteArray = ListToArray(PageRouteList,"|")>
  <cfset PageRouteCounterArray = ListToArray(PageRouteCounterList,"|")>
  <cfloop from="1" to="#ListLen(PageRouteCounterList,"|")#" index="j">
  	<cfloop from="1" to="#ListLen(PageRouteCounterList,"|")#" index="k">
  		<cfif PageRouteCounterArray[j] gt PageRouteCounterArray[k]>
  			<cfset temp = ArraySwap(PageRouteArray,k,j)>
  			<cfset temp = ArraySwap(PageRouteCounterArray,k,j)>
  		</cfif>
  	</cfloop>
  </cfloop>
  <cfset UniqueRefererArray = ListToArray(UniqueRefererList,"|")>
  <cfset UniqueRefererCounterArray = ListToArray(UniqueRefererCounterList,"|")>
  <cfloop from="1" to="#ListLen(UniqueRefererCounterList,"|")#" index="j">
  	<cfloop from="1" to="#ListLen(UniqueRefererCounterList,"|")#" index="k">
  		<cfif UniqueRefererCounterArray[j] gt UniqueRefererCounterArray[k]>
  			<cfset temp = ArraySwap(UniqueRefererArray,k,j)>
  			<cfset temp = ArraySwap(UniqueRefererCounterArray,k,j)>
  		</cfif>
  	</cfloop>
  </cfloop>
  <cfset UniqueUserAgentArray = ListToArray(UniqueUserAgentList,"|")>
  <cfset UniqueUserAgentCounterArray = ListToArray(UniqueUserAgentCounterList,"|")>
  <cfloop from="1" to="#ListLen(UniqueUserAgentCounterList,"|")#" index="j">
  	<cfloop from="1" to="#ListLen(UniqueUserAgentCounterList,"|")#" index="k">
  		<cfif UniqueUserAgentCounterArray[j] gt UniqueUserAgentCounterArray[k]>
  			<cfset temp = ArraySwap(UniqueUserAgentArray,k,j)>
  			<cfset temp = ArraySwap(UniqueUserAgentCounterArray,k,j)>
  		</cfif>
  	</cfloop>
  </cfloop>

  <!--- <cfoutput>#ArrayToList(UniqueRefererArray)# #ArrayToList(UniqueRefererCounterArray)#</cfoutput> --->

  
  <div style="padding:20px 40px;">
  	
  	<div id="admin_Reporter_Header" style="border-bottom-right-radius:0;-moz-border-radius-bottomright:0;">
  		<cfoutput>
    		<div style="float:left;font-weight:bold;">Lastest Activity</div>
    		<div style="float:right;">
 		  		<!--- <select name="Selector" id="Selector" onChange="window.location='?select='+this.value+'&sort=#url.sort#'" style="margin-right:20px;">
 		  			<option value="0" style="font-weight:bold;">DISPLAY ALL</option>
 		  			<hr />
 		  			<cfloop query="ForeignTable">
 		  				<option value="#ForeignTable.ID#" <cfif url.select eq ForeignTable.ID>selected</cfif>>#Evaluate("ForeignTable." & FilterMenuFieldName)#</option>
 		  			</cfloop>
 		  		</select> --->
 		  		<form method="post">
   					In The Last
   					<select name="intervalcount">
   						<cfloop from="1" to="90" index="i">
   							<option value="#i#" <cfif IsDefined("form.intervalcount") and form.intervalcount eq i>selected</cfif>>#i#</option>
   						</cfloop>
   					</select>
   					<select name="interval">
   						<cfloop list="Minute,Hour,Day,Week,Month,Year" index="i">
   							<option value="#i#" <cfif IsDefined("form.interval") and form.interval eq i>selected</cfif>>#i#s</option>
   						</cfloop>
   					</select>
   					<input type="submit" name="submit_btn" value="Refresh">
 					</form>
    		</div>
  		</cfoutput>
  	</div>
  	
  	<div style="height:200px;overflow-y:scroll;">
	  	<table id="reporterTable" width="100%" border="0" cellspacing="1">
	  		<tr>
	  			<th style="padding:0px;"><div class="table_ColumnTab">Name</div></th>
	  			<!--- <th style="padding:0px;"><div class="table_ColumnTab">Duration</div></th>
	  			<th style="padding:0px;"><div class="table_ColumnTab">Started</div></th> --->
	  			<th style="padding:0px;"><div class="table_ColumnTab">Last Activity</div></th>
	  			<th style="padding:0px;"><div class="table_ColumnTab">Page Views</div></th>
	  			<th style="padding:0px;"><div class="table_ColumnTab">Pages Viewed</div></th>
	  		</tr>
	  		<cfoutput query="Stats">
	  			<tr class="table_Row_RolloverHighlight" style="cursor:pointer;" onClick="window.open('stat_detail.cfm?id=#ID#','','width=900,height=300,status=1,scrollbars=1,resizable=1')">
						<td><div class="table_DataCell"><cfif SessionName neq "" and SessionName neq "Anonymous">#SessionName#<cfelse><i style="color:gray;">Anonymous</i></cfif></div></td>
						<!--- <td><div class="table_DataCell"><cfif IsDate(SessionStarted_dt) and IsDate(SessionLastRequest_dt)>#DateDiff("n",SessionStarted_dt,SessionLastRequest_dt)# Minutes<cfelse>-</cfif></div></td>
						<td><div class="table_DataCell">
							<cfif IsDate(SessionStarted_dt)>
	  						<cfif DateFormat(SessionStarted_dt,"short") eq DateFormat(Now(),"short")>
	  							Today @ 
	  							<cfelse>
	  							#DateFormat(SessionStarted_dt,"short")# @ 
	  						</cfif>
	  						#TimeFormat(SessionStarted_dt,"short")#
	  						<cfelse>
	  						&nbsp;
							</cfif>
						</div></td> --->
						<td><div class="table_DataCell">
							<cfif IsDate(SessionLastRequest_dt)>
	  						<cfif DateFormat(SessionLastRequest_dt,"short") eq DateFormat(Now(),"short")>
	  							Today @ 
	  							<cfelse>
	  							#DateFormat(SessionLastRequest_dt,"short")# @ 
	  						</cfif>
	  						#TimeFormat(SessionLastRequest_dt,"short")#
	  						<cfelse>
	  						&nbsp;
							</cfif>
						</div></td>
						<td><div class="table_DataCell">
							#ListLen(SessionHistory)#
						</div></td>
						<td><div class="table_DataCell">#Left(Replace(SessionHistory,",",", ","all"),50)##IIf(Len(SessionHistory) gt 50,DE("..."),DE(""))#</div></td>
					</tr>
	  		</cfoutput>
	  	</table>
  	</div>
    &nbsp;
  	<table width="100%" border="0" cellspacing="1">
  		<tr>
  			<th class="table_ColumnTab">Unique Visitor Histogram</th>
  		</tr>
  		<tr style="background-color:#DDD">
  			<td class="table_DataCell">
  				<cfset BarWidth = 1 / (Abs(IntervalCount) + 1) * 100>
  				<table width="100%" cellpadding="0" cellspacing="1" border="0" style="margin:10px 0px;">
  					<tr>
  						<cfset MaxHitsPerInterval = 0>
  						<cfloop from="1" to="#Abs(IntervalCount)#" index="i">
	 							<cfquery name="Interval_#i#" datasource="#Application.psDataSource#">
	 							select ID from #Application.psStatsTable# where SessionStarted_dt > dateadd(#Interval#,#-IntervalCount + i#,#AdjNowDate#) and SessionStarted_dt < dateadd(#Interval#,#-IntervalCount + i + 1#,#AdjNowDate#) order by SessionStarted_dt
	 							</cfquery>
  							<cfset ThisIntervalCount = Evaluate("Interval_#i#.Recordcount")>
  							<cfif ThisIntervalCount gt MaxHitsPerInterval>
  								<cfset MaxHitsPerInterval = ThisIntervalCount>
  							</cfif>
  						</cfloop>
  						
		  				<cfloop from="1" to="#Abs(IntervalCount)#" index="i">
		  					<cfoutput>
		  						<td width="#BarWidth#%" valign="bottom" style="background-color:##CCC;height:120px;">
		  							<cfif MaxHitsPerInterval gt 0>
		  								<div style="width:100%;text-align:center;background-color:blue;color:white;height:#Evaluate("Interval_#i#.RecordCount") / MaxHitsPerInterval * 100#%">
		  									<cfset VisitsThisInterval = Evaluate("Interval_#i#.RecordCount")>
		  									<cfif VisitsThisInterval gt MaxHitsPerInterval/5>#VisitsThisInterval#</cfif>
		  									<!--- #Evaluate("Interval_#i#.RecordCount") / MaxHitsPerInterval * 100# --->
		  								</div>
		  							</cfif>
		  						</td>
		  					</cfoutput>
		  				</cfloop>
	  				</tr>
  					<tr>
  						<cfset DatepartConversionList = "">
		  				<cfloop from="1" to="#Abs(IntervalCount)#" index="i">
		  					<cfoutput>
		  						<td align="center" valign="top" nowrap="nowrap">
		  							<div style="width:100%;background-color:##CCC;">
		  								<!--- #Evaluate("Interval_#i#.RecordCount")# --->
		  								<cfif Interval eq "Minute">
		  									#TimeFormat(DateAdd("m",-IntervalCount+i,AdjNowDate),"mm")#
		  									<cfelseif Interval eq "Hour">
		  									#TimeFormat(DateAdd("h",-IntervalCount+i,AdjNowDate),"h tt")#
		  									<cfelseif Interval eq "Day">
		  									#DateFormat(DateAdd("d",-IntervalCount+i,AdjNowDate),"dd")#
		  									<cfelseif Interval eq "Week">
		  									#DateFormat(DateAdd("ww",-IntervalCount+i,AdjNowDate),"m/d")#
		  									<cfelseif Interval eq "Month">
		  									#DateFormat(DateAdd("m",-IntervalCount+i,AdjNowDate),"mmm")#
		  									<cfelseif Interval eq "Year">
		  									#DateFormat(DateAdd("yyyy",-IntervalCount+i,AdjNowDate),"yyyy")#
		  								</cfif>
		  							</div>
		  						</td>
		  					</cfoutput>
		  				</cfloop>
	  				</tr>
  				</table>
  			</td>
  		</tr>
    </table>
    &nbsp;
  	<table width="100%" border="0" cellspacing="1">
  		<tr>
  			<th class="table_ColumnTab" colspan="4">Page Hits</th>
  		</tr>
  		<cfloop from="1" to="#ListLen(PageCountList)#" index="i">
  			<tr class="table_Row_RolloverHighlight">
  				<td class="table_DataCell"><cfoutput>#ListGetAt(PageList,i)#</cfoutput></td>
  				<td class="table_DataCell" align="right"><cfoutput>#ListGetAt(PageCountList,i)#</cfoutput></td>
  				<cfset CurrentPercentage = ListGetAt(PageCountList,i)/TotalPageViews*100>
  				<td class="table_DataCell" align="right"><cfoutput>#NumberFormat(CurrentPercentage,"_._")#%</cfoutput></td>
  				<td class="table_DataCell" width="30%"><cfoutput><div style="width:#Fix(CurrentPercentage)#%;background-color:blue;height:10px;"></div></cfoutput></td>
  			</tr>
  		</cfloop>

    	<tr>
    		<td>&nbsp;</td>
    	</tr>

  		<tr>
  			<th class="table_ColumnTab" colspan="4">Common Page Routes</th>
  		</tr>
  		<cfset PageRouteCount = 0>
  		<cfloop list="#ArrayToList(PageRouteCounterArray)#" index="CurrentItem">
  			<cfif CurrentItem gt 1>
  				<cfset PageRouteCount = PageRouteCount + CurrentItem>
  			</cfif>
  		</cfloop>
  		<cfloop from="1" to="#ArrayLen(PageRouteCounterArray)#" index="i">
  			<cfif PageRouteCounterArray[i] eq 1>
  				<cfbreak>
  			</cfif>
  			<tr class="table_Row_RolloverHighlight">
  				<td class="table_DataCell"><cfoutput>#Left(Replace(PageRouteArray[i],","," <b style=""color:blue;"">&gt;</b> ","all"),75)##IIf(Len(PageRouteArray[i]) gt 75,DE("..."),DE(""))#</cfoutput></td>
  				<td class="table_DataCell" align="right"><cfoutput>#PageRouteCounterArray[i]#</cfoutput></td>
  				<cfset CurrentPercentage = PageRouteCounterArray[i]/PageRouteCount*100>
  				<td class="table_DataCell" align="right"><cfoutput>#NumberFormat(CurrentPercentage,"_._")#%</cfoutput></td>
  				<td class="table_DataCell" width="30%"><cfoutput><div style="width:#Fix(CurrentPercentage)#%;background-color:blue;height:10px;"></div></cfoutput></td>
  			</tr>
  		</cfloop>

    	<tr>
    		<td>&nbsp;</td>
    	</tr>

  		<tr>
  			<th class="table_ColumnTab" colspan="4">All Referers</th>
  		</tr>
  		<cfset TotalReferers = ArraySum(ListToArray(UniqueRefererCounterList,"|"))>
  		<cfloop from="1" to="#ArrayLen(UniqueRefererCounterArray)#" index="i">
  			<tr class="table_Row_RolloverHighlight">
  				<td class="table_DataCell"><cfoutput>#Left(Replace(UniqueRefererArray[i],",",", ","all"),75)##IIf(Len(UniqueRefererArray[i]) gt 75,DE("..."),DE(""))#</cfoutput></td>
  				<td class="table_DataCell" align="right"><cfoutput>#UniqueRefererCounterArray[i]#</cfoutput></td>
  				<cfset CurrentPercentage = UniqueRefererCounterArray[i]/TotalReferers*100>
  				<td class="table_DataCell" align="right"><cfoutput>#NumberFormat(CurrentPercentage,"_._")#%</cfoutput></td>
  				<td class="table_DataCell" width="30%"><cfoutput><div style="width:#Fix(CurrentPercentage)#%;background-color:blue;height:10px;"></div></cfoutput></td>
  			</tr>
  		</cfloop>

    	<tr>
    		<td>&nbsp;</td>
    	</tr>

  		<tr>
  			<th class="table_ColumnTab" colspan="4">Common User Agents</th>
  		</tr>
  		<cfset TotalUserAgents = 0>
  		<cfloop list="#ArrayToList(UniqueUserAgentCounterArray)#" index="CurrentItem">
  			<cfif CurrentItem gt 1>
  				<cfset TotalUserAgents = TotalUserAgents + CurrentItem>
  			</cfif>
  		</cfloop>
  		<cfloop from="1" to="#ArrayLen(UniqueUserAgentCounterArray)#" index="i">
  			<cfif UniqueUserAgentCounterArray[i] eq 1>
  				<cfbreak>
  			</cfif>
  			<tr class="table_Row_RolloverHighlight">
  				<td class="table_DataCell"><cfoutput>#Left(Replace(UniqueUserAgentArray[i],",",", ","all"),120)##IIf(Len(UniqueUserAgentArray[i]) gt 120,DE("..."),DE(""))#</cfoutput></td>
  				<td class="table_DataCell" align="right" valign="top"><cfoutput>#UniqueUserAgentCounterArray[i]#</cfoutput></td>
  				<cfset CurrentPercentage = UniqueUserAgentCounterArray[i]/TotalUserAgents*100>
  				<td class="table_DataCell" align="right" valign="top"><cfoutput>#NumberFormat(CurrentPercentage,"_._")#%</cfoutput></td>
  				<td class="table_DataCell" width="30%"><cfoutput><div style="width:#Fix(CurrentPercentage)#%;background-color:blue;height:10px;"></div></cfoutput></td>
  			</tr>
  		</cfloop>
  	</table>
  	
  </div>
		
	
	<cfelse>
	<cflocation url="/admin/?session=expired">
</cfif>
</body>
</html>

