<cftransaction>
  <cfquery name="Init" datasource="#Application.psDataSource#">
  <!--- create psSchemaTable --->
	if not exists (select 1 from information_schema.tables where table_type = 'BASE TABLE' and table_name = '#Application.psSchemaTable#') 
	  begin 
	  	create table dbo.#Application.psSchemaTable# (ID integer primary key identity(1,1), Queue integer, TableName varchar(50), FieldName varchar(50), FieldSet varchar(50), DataType varchar(50), Subtype varchar(50), Display bit default 0, Summary bit default 0, Sortable bit default 0, Editable bit default 0, Required bit default 0, Datasize int, Options text, AllowNull bit default 1, DefaultValue varchar(50), Notes text, UserOverride bit, Calculate bit, Summate bit, Encrypt bit);
    	select 'initialize' as Status;
	  end
    else
    	select 'false' as Status;
	<!--- create psAccountsTable --->
	if not exists (select 1 from information_schema.tables where table_type = 'BASE TABLE' and table_name = '#Application.psAccountsTable#')
		begin
			create table dbo.#Application.psAccountsTable# (ID integer PRIMARY KEY IDENTITY(1,1), Username varchar(50), Password varchar(50), Access varchar(50), FirstName varchar(50), LastName varchar(50), Name varchar(50), LastLogin datetime);
	  	insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (1,'#Application.psAccountsTable#','ID','','int','primarykey',0,0,0,0,1,0);
	  	insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (2,'#Application.psAccountsTable#','Username','Account Details','varchar','email',1,1,1,1,1,50);
	  	insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (3,'#Application.psAccountsTable#','Password','Account Details','varchar','password',0,0,0,1,1,50);
	  	insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize,Options) values (4,'#Application.psAccountsTable#','Access','Account Details','varchar','text',1,1,1,1,1,50,'Select:#Application.psDefaultAccessLevels#');
	  	insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (5,'#Application.psAccountsTable#','FirstName','Personal Details','varchar','text',1,1,1,1,1,50);
	  	insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (6,'#Application.psAccountsTable#','LastName','Personal Details','varchar','text',1,1,1,1,1,50);
	  	insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Options) values (7,'#Application.psAccountsTable#','Name','Personal Details','varchar','text',1,1,1,1,1,'Calculate:IIf(Table.LastName neq "" and Table.FirstName neq "",DE(Table.LastName & ", " & Table.FirstName),DE(""))');
	  	insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize,Options) values (8,'#Application.psAccountsTable#','Groups','Groups','list','grouplist',0,0,0,1,0,50,'2,GroupName,MemberIDs,#Application.psTablePrefix#Groups');
		end
	<!--- create psLoginsTable --->
	if not exists (select 1 from information_schema.tables where table_type = 'BASE TABLE' and table_name = '#Application.psLoginsTable#')
		begin
			create table dbo.#Application.psLoginsTable# (ID integer PRIMARY KEY IDENTITY(1,1), Username varchar(50), Password varchar(50), Access varchar(50), Timestamp datetime, Successful bit default 0);
			insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize,Options) values (1,'#Application.psLoginsTable#','ID','','int','',0,0,0,0,0,0,'');
			insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize,Options) values (2,'#Application.psLoginsTable#','Username','','varchar','',0,0,0,0,0,50,'');
			insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize,Options) values (3,'#Application.psLoginsTable#','Password','','varchar','',0,0,0,0,0,50,'');
			insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize,Options) values (4,'#Application.psLoginsTable#','Access','','varchar','',0,0,0,0,0,50,'');
			insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize,Options) values (5,'#Application.psLoginsTable#','Timestamp','','datetime','',0,0,0,0,0,0,'');
			insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize,Options) values (6,'#Application.psLoginsTable#','Successful','','bit','',0,0,0,0,0,0,'');
		end
	<!--- create psGroupsTable --->
  if not exists (select 1 from information_schema.tables where table_type = 'BASE TABLE' and table_name = '#Application.psGroupsTable#') 
  	begin
    	create table dbo.#Application.psGroupsTable# (ID integer primary key identity(1,1), Queue integer, #Application.psAccountsTable#ID integer, GroupName varchar(50), MemberIDs text);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (1,'#Application.psGroupsTable#','ID','','int','primarykey',0,0,0,0,1,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (2,'#Application.psGroupsTable#','Queue','','int','integer',1,0,1,0,0,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (4,'#Application.psGroupsTable#','GroupName','Group Details','varchar','text',1,0,1,1,0,50);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (5,'#Application.psGroupsTable#','MemberIDs','','text','text',0,0,0,0,0,0);
    end
  <!--- create psAdminPagesTable (uses custom editor but still needs schema for reporter requeue) --->
  if not exists (select 1 from information_schema.tables where table_type = 'BASE TABLE' and table_name = '#Application.psAdminPagesTable#') 
  	begin
    	create table dbo.#Application.psAdminPagesTable# (ID integer primary key identity(1,1), Queue int, ps_Menu varchar(50), ps_PageTitle varchar(50), ps_FileName varchar(50), ps_PageSubtype varchar(50), ps_DefaultQueryString text, ps_Summary varchar(50), ps_AccessRequired bit, ps_Access text, ps_DataTable varchar(50), ps_RecordName varchar(50), ps_Editor varchar(50), ps_EditorAccess text, ps_EditorWindowSize varchar(50), ps_Viewer varchar(50), ps_ViewerAccess text, ps_ViewerWindowSize varchar(50));
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (1,'#Application.psAdminPagesTable#','ID','','int','primarykey',0,0,0,0,1,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (2,'#Application.psAdminPagesTable#','Queue','','int','integer',1,1,1,0,0,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (3,'#Application.psAdminPagesTable#','ps_Menu','','varchar','text',1,1,1,1,0,50);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (4,'#Application.psAdminPagesTable#','ps_PageTitle','','varchar','text',1,1,1,1,0,50);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (5,'#Application.psAdminPagesTable#','ps_FileName','','varchar','text',1,1,1,1,0,50);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (6,'#Application.psAdminPagesTable#','ps_PageSubtype','','varchar','text',1,1,1,1,0,50);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (7,'#Application.psAdminPagesTable#','ps_DefaultQueryString','','text','text',0,0,0,1,0,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (8,'#Application.psAdminPagesTable#','ps_Summary','','varchar','text',1,1,1,1,0,50);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (9,'#Application.psAdminPagesTable#','ps_AccessRequired','','bit','yes/no',0,0,0,1,0,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (10,'#Application.psAdminPagesTable#','ps_Access','','text','text',0,0,0,1,0,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (11,'#Application.psAdminPagesTable#','ps_DataTable','','varchar','text',1,1,1,1,0,50);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (12,'#Application.psAdminPagesTable#','ps_RecordName','','varchar','text',0,0,0,1,0,50);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (13,'#Application.psAdminPagesTable#','ps_Editor','','varchar','text',1,1,1,1,0,50);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (14,'#Application.psAdminPagesTable#','ps_EditorAccess','','text','text',0,0,0,1,0,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (15,'#Application.psAdminPagesTable#','ps_EditorWindowSize','','varchar','text',0,0,0,1,0,50);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (16,'#Application.psAdminPagesTable#','ps_Viewer','','varchar','text',1,1,1,1,0,50);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (17,'#Application.psAdminPagesTable#','ps_ViewerAccess','','text','text',0,0,0,1,0,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (18,'#Application.psAdminPagesTable#','ps_ViewerWindowSize','','varchar','text',0,0,0,1,0,50);
    	<!--- insert admin page records into psAdminPagesTable --->
    	insert into #Application.psAdminPagesTable# (Queue,ps_Menu,ps_PageTitle,ps_FileName,ps_PageSubtype,ps_Summary,ps_AccessRequired,ps_Access,ps_DataTable,ps_RecordName,ps_Editor,ps_EditorAccess,ps_EditorWindowSize,ps_Viewer,ps_ViewerAccess,ps_ViewerWindowSize)
    		values (1,'People','People','accounts.cfm','reporter','',1,'Webmaster,Administrator','#Application.psAccountsTable#','Person','person.cfm','Webmaster,Administrator','640,640','','','');
    	insert into #Application.psAdminPagesTable# (Queue,ps_Menu,ps_PageTitle,ps_FileName,ps_PageSubtype,ps_Summary,ps_AccessRequired,ps_Access,ps_DataTable,ps_RecordName,ps_Editor,ps_EditorAccess,ps_EditorWindowSize,ps_Viewer,ps_ViewerAccess,ps_ViewerWindowSize)
    		values (2,'People','Groups','groups.cfm','reporter','',1,'Webmaster,Administrator','#Application.psGroupsTable#','Group','group.cfm','Webmaster,Administrator','640,240','','','');
    	insert into #Application.psAdminPagesTable# (Queue,ps_Menu,ps_PageTitle,ps_FileName,ps_PageSubtype,ps_Summary,ps_AccessRequired,ps_Access,ps_DataTable,ps_RecordName,ps_Editor,ps_EditorAccess,ps_EditorWindowSize,ps_Viewer,ps_ViewerAccess,ps_ViewerWindowSize)
    		values (3,'Pages','Admin Pages','adminpages.cfm','reporter','',1,'Webmaster','#Application.psAdminPagesTable#','Admin Page','adminpage.cfm','Webmaster','640,640','','','');
    end
  <!--- create psSearchTable --->
  if not exists (select 1 from information_schema.tables where table_type = 'BASE TABLE' and table_name = '#Application.psSearchTable#') 
  	create table dbo.#Application.psSearchTable# (ID integer primary key identity(1,1), Username varchar(50), TableName varchar(50), QueryString text, SearchName varchar(50), Timestamp datetime);
  <!--- create psMessageLogTable -- may not need a schema, uses a custom editor --->
  if not exists (select 1 from information_schema.tables where table_type = 'BASE TABLE' and table_name = '#Application.psMessageLogTable#') 
  	begin
    	create table dbo.#Application.psMessageLogTable# (ID integer primary key identity(1,1), Sender varchar(80), SenderAsEntered varchar(80), Selector varchar(50), RecipientList text, Subject varchar(80), RecipientResults text, Message text, Attachment text, Sent datetime, Importance varchar(50));
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (1,'#Application.psMessageLogTable#','ID','','int','primarykey',0,0,0,0,1,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (2,'#Application.psMessageLogTable#','Sender','','varchar','email',1,1,1,0,0,80);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (3,'#Application.psMessageLogTable#','SenderAsEntered','','varchar','email',1,1,1,0,0,80);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (4,'#Application.psMessageLogTable#','Selector','','varchar','text',0,0,0,0,0,50);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (5,'#Application.psMessageLogTable#','RecipientList','','text','text',0,0,0,0,0,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (6,'#Application.psMessageLogTable#','Subject','','varchar','text',1,1,1,0,0,80);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (7,'#Application.psMessageLogTable#','RecipientResults','','text','text',0,0,0,0,0,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (8,'#Application.psMessageLogTable#','Message','','text','text',0,0,0,0,0,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (9,'#Application.psMessageLogTable#','Attachment','','text','text',0,0,0,0,0,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (10,'#Application.psMessageLogTable#','Sent','','datetime','datetime',0,0,0,0,0,0);
  		insert into #Application.psSchemaTable# (Queue,TableName,FieldName,FieldSet,DataType,Subtype,Display,Summary,Sortable,Editable,Required,Datasize) values (11,'#Application.psMessageLogTable#','Importance','','varchar','text',0,0,0,0,0,50);
    end
  </cfquery>
</cftransaction>
