<cfset Table = Report.Query>
<cfset Schema = Report.Schema>

<script src="/js/tablednd.js"></script>

<div id="admin_Reporter_Header">
	<cfoutput>
		<div style="float:left;font-weight:bold;">Reorder #Replace(TableName,"_"," ","all")#</div>
		<div style="float:right"><input type="button" onclick="window.location.href='#Reporter#'" value="Done"></div>
	</cfoutput>
</div>

<table width="100%" cellspacing="1" cellpadding="0" style="margin-bottom:-1px;">
	<tr>
		<td>
			<div class="table_ColumnTab" style="background-color:#FCC;">
				<div style="float:left">Drag and drop rows to change their order.</div>
				<div style="float:right">Click <strong>Done</strong> above when finished.</div>
			</div>
		</td>
	</tr>
</table>

<table id="table-1" width="100%" border="0" cellspacing="1" cellpadding="3">
	<!--- removed original header row --->
	<cfoutput query="Table">
		<tr id="#CurrentRow#" class="table_Row_RolloverHighlight">
			<cfset i = 0>
			<cfloop list="#ValueList(Schema.FieldName)#" index="CurrentItem">
				<cfset i = i + 1>
				<cfif Schema.Display[i]>
					<td style="padding:2px 10px;"><cfswitch expression="#Schema.DataType[i]#">
							<cfcase value="bit">
							<cfif Schema.Subtype[i] eq "yes/no">
								#IIf(Evaluate(CurrentItem) eq 1,DE("Yes"),DE("No"))#
								<cfelseif Schema.Subtype[i] eq "dot/dash">
								<cfif Evaluate(CurrentItem)>
									<strong style="color:##060">&bull;</strong>
									<cfelse>
									<span style="color:##C00">-</span>
								</cfif>
								<cfelseif Schema.Subtype[i] eq "true/false">
								#IIf(Evaluate(CurrentItem),DE("True"),DE("False"))#
								<cfelse>
								#Evaluate(CurrentItem)#
							</cfif>
							</cfcase>
							<cfcase value="datetime">
							#DateFormat(Evaluate(CurrentItem),"yyyy-mm-dd")#
							<cfif Schema.Subtype[i] eq "datetime">
								#TimeFormat(Evaluate(CurrentItem),"short")#
							</cfif>
							</cfcase>
							<cfcase value="int">
							<cfif Schema.Subtype[i] eq "foreignkey" and ListGetAt(Schema.Options[i],2) neq "-">
								<cfset MyLabelOptionString = ListGetAt(Schema.Options[i],2)>
								<cfif ListLen(MyLabelOptionString,":") gte 2>
									<cfset RelatedFieldName = ListGetAt(MyLabelOptionString,1,":")>
									<cfset MyLabel = Trim(REReplace(ListGetAt(MyLabelOptionString,2,":"),"([A-Z])"," \1","all"))>
									<cfelse>
									<cfset RelatedFieldName = MyLabelOptionString>
									<cfset MyLabel = Trim(REReplace(MyLabelOptionString,"([A-Z])"," \1","all"))>
								</cfif>
								<cfquery name="Relative" datasource="#Application.psDataSource#">
								select #RelatedFieldName# as ThisValue from #ListGetAt(Schema.Options[i],3)# where ID = #Val(Evaluate(CurrentItem))#
								</cfquery>
								#Relative.ThisValue#
								<cfelse>
								#Evaluate(CurrentItem)#
							</cfif>
							</cfcase>
							<cfdefaultcase>
							<cfif ListFind(Application.psNonStandardDataTypes,Schema.DataType[i])>
								UnsupportedDataType
								<cfelse>
								#Evaluate(CurrentItem)#
							</cfif>
							</cfdefaultcase>
						</cfswitch></td>
				</cfif>
			</cfloop>
		</tr>
	</cfoutput>
</table>

<div id="debug" style="float:left;"></div>

<script>
var table = document.getElementById('table-1');
var tableDnD = new TableDnD();
// Redefine the findDropTargetRow to put some debug information in
tableDnD.findDropTargetRow = function(y) {
	var rows = this.table.tBodies[0].rows;
	var debugStr = "y is "+y+"<br>";
	for (var i=0; i<rows.length; i++) {
		var row = rows[i];
		var rowY		= this.getPosition(row).y;
		var rowHeight = parseInt(row.offsetHeight)/2;
	if (row.offsetHeight == 0) {
		rowY = this.getPosition(row.firstChild).y;
		rowHeight = parseInt(row.firstChild.offsetHeight)/2;
	}
	// debugStr += "row["+i+"] between "+(rowY-rowHeight)+' and '+(rowY+rowHeight)+"<br>";
		// Because we always have to insert before, we need to offset the height a bit
		if ((y > rowY - rowHeight) && (y < (rowY + rowHeight))) {
			// that's the row we're over
			// document.getElementById('debug').innerHTML = debugStr+"found row";
			return row;
		}
	}
	// document.getElementById('debug').innerHTML = debugStr+"no matching row";
	return null;
}
// Redefine the onDrop so that we can display something
tableDnD.onDrop = function(table, row) {
	var rows = this.table.tBodies[0].rows;
	var debugStr = "";
		for (var i=0; i<rows.length; i++) {
		debugStr += rows[i].id;
		if (i < rows.length-1) debugStr += ",";
	}
	// document.getElementById('debug').innerHTML = 'row['+row.id+'] dropped<br>'+debugStr;
	// if (confirm('Are you sure you want to reorder these products?')) {
	if (true) {
		<cfoutput>window.location = '#cgi.PathInfo#?requeue='+ debugStr;</cfoutput>
		// setTimeout("window.opener.location.reload()",500);
	} else {
		window.location.reload();
	}
}
 
tableDnD.init(table);
</script>
